// convf.c
//
// YV12 -> YUY2 ϊ֐iJ[AbvTvj
//
// func(unsigned char *dst, unsigned char *src, unsigned char *temp, 
//      long width_in, long width_out, long height)
//   unsigned char *dst  : Rs[ւ̃|C^
//   unsigned char *src  : Rs[
//   unsigned char *temp : e|̈iTCY width_in * height * 2j
//   long width_in       : ͉摜̕iXgCh܂ށj
//   long width_out      : o͉摜̕iXgCh܂ށj
//   long height         : 摜̍
//
// ۂ̉摜͓̈̕nȂ̂ŁAwidth_in  width_out ̏ق̕Rs[
//
// YUY2:
//   Y0 U0 Y1 V0
// YV12:(s:stride)
//   YYss
//   YYss
//   Vs
//   Us
//
// V,U͎ۂ̒l128́B܂YUVׂ unsigned char ƈ
//
#include "convf.h"


// ϊ֐e[u ֐̐"FUNC_N"ł̓~Xh~̂߂炩ߐݒ肵Ă
void (*func_tbl[FUNC_N])(unsigned char *, unsigned char *, unsigned char *, long, long, long) = {
	yv12_2_yuy2,
	yv12_2_yuy2_2,
	yv12_2_yuy2_4,
	yv12_2_yuy2_6,
	iyv12_2_yuy2,
	iyv12_2_yuy2_2,
	iyv12_2_yuy2_2x,
	iyv12_2_yuy2_4,
	iyv12_2_yuy2_4x };


/*
 *   p[eBeB[֐
 */
static void transpose(unsigned char *, unsigned char *, long, long, long);

/*
 * vO YV12 -> YUY2
 * nearest neighbor
 *
 */
void yv12_2_yuy2(unsigned char *dst, unsigned char *src, unsigned char *temp, 
			long width_in, long width_out, long height)
{
	int i,j;
	int h_width = width_in >> 1;
	int offsY = width_in * height;
	int offsV = offsY >> 2;
	unsigned char *dst_tmp, *src_vtmp;
	unsigned char *src_v = src + offsY;

	for(i=0; i<height; ++i) {
		dst_tmp = dst + (i+i) * width_out;
		src_vtmp = src_v + (i>>1) * h_width;
		for(j=0; j<h_width; ++j) {
			//Y0
			*dst_tmp       = *src;
			//U0
			*(dst_tmp + 1) = *(src_vtmp + offsV);
			//Y1
			*(dst_tmp + 2) = *(src + 1);
			//V0
			*(dst_tmp + 3) = *src_vtmp;

			src += 2;
			src_vtmp++;
			dst_tmp += 4;
		}
	}
}


/*
 * vO YV12 -> YUY2
 * 2Tv
 * W 0.9, 0.1
 * 
 */
void yv12_2_yuy2_2(unsigned char *dst, unsigned char *src, unsigned char *temp, 
			long width_in, long width_out, long height)
{
	int i,j;
	int uv_tmp;
	int h_width = width_in >> 1;
	int h_height = height >> 1;
	int offsY = width_in * height;
	int offsV = offsY >> 2;
	unsigned char *dst_tmp = dst;
	unsigned char *src_v = src + offsY;
	unsigned char *src_vtmp0 = src_v;
	unsigned char *src_vtmp1;

	// ŏ1line
	for(j=0; j<h_width; ++j) {
		//Y0
		*dst_tmp       = *src;
		//U0
		*(dst_tmp + 1) = *(src_vtmp0 + offsV);
		//Y1
		*(dst_tmp + 2) = *(src + 1);
		//V0
		*(dst_tmp + 3) = *src_vtmp0;

		src += 2;
		src_vtmp0++;
		dst_tmp += 4;
	}

	--height;
	for(i=1; i<height; ++i) {
		dst_tmp = dst + (i+i) * width_out;
		src_vtmp0 = src_v + (i>>1) * h_width;
		src_vtmp1 = src_vtmp0 + ((1&i)*2 - 1) * h_width;
		for(j=0; j<h_width; ++j) {
			//Y0
			*dst_tmp       = *src;
			//U0
			uv_tmp = *(src_vtmp0 + offsV) * 29491 + *(src_vtmp1 + offsV) * 3277;
			uv_tmp = (uv_tmp + 16383) >> 15;
			*(dst_tmp + 1) = uv_tmp;
			//Y1
			*(dst_tmp + 2) = *(src + 1);
			//V0
			uv_tmp = *src_vtmp0 * 29491 + *src_vtmp1 * 3277 + 16383;
			uv_tmp >>= 15;
			*(dst_tmp + 3) = uv_tmp;

			src += 2;
			src_vtmp0++;
			src_vtmp1++;
			dst_tmp += 4;
		}
	}

	//Ō1C
	dst_tmp = dst + (i+i) * width_out;
	src_vtmp0 = src_v + (h_height-1) * h_width;
	for(j=0; j<h_width; ++j) {
		//Y0
		*dst_tmp       = *src;
		//U0
		*(dst_tmp + 1) = *(src_vtmp0 + offsV);
		//Y1
		*(dst_tmp + 2) = *(src + 1);
		//V0
		*(dst_tmp + 3) = *src_vtmp0;

		src += 2;
		src_vtmp0++;
		dst_tmp += 4;
	}

}

/*
 * vO YV12 -> YUY2
 * 4Tv
 * W -0.083, 0.87, 0.23, -0.017
 *
 * uv_tmp = *(src_vtmp0 + offsV) * 0.8686  + *(src_vtmp1 + offsV) * 0.2330
 *			- *(src_vtmp2 + offsV) * 0.08388 - *(src_vtmp3 + offsV) * 0.01772;
 * 
 */
void yv12_2_yuy2_4(unsigned char *dst, unsigned char *src, unsigned char *temp, 
			long width_in, long width_out, long height)
{
	int i,j;
	int tmp;
	int l1, l2, l3;
	int h_width = width_in >> 1;
	int h_height = height >> 1;
	int offsY = width_in * height;
	int offsV = offsY >> 2;
	unsigned char *dst_tmp = dst;
	unsigned char *src_v = src + offsY;
	unsigned char *src_vtmp0, *src_vtmp1, *src_vtmp2, *src_vtmp3;

	for(i=0; i<height; ++i) {
		dst_tmp = dst + (i+i) * width_out;
		tmp = (i>>1);
		src_vtmp0 = src_v + tmp * h_width;
		l1 = (1&i)*2 - 1;
		l2 = tmp - l1;
		l3 = tmp + l1 + l1;
		l1 += tmp;

		if(l3>0 && l3<h_height){
			src_vtmp3 = src_v + l3 * h_width;
			src_vtmp1 = src_v + l1 * h_width;
		}else if(l1>0 && l1<h_height){
			src_vtmp3 = src_vtmp1 = src_v + l1 * h_width;
		}else{
			src_vtmp3 = src_vtmp1 = src_v;
		}

		if(l2>0 && l2<h_height){
			src_vtmp2 = src_v + l2 * h_width;
		}else{
			src_vtmp2 = src_v;
		}

		for(j=0; j<h_width; ++j) {
			//Y0
			*dst_tmp       = *src;
			//U0
			tmp =   *(src_vtmp0 + offsV) * 28462 + *(src_vtmp1 + offsV) * 7635
				  - *(src_vtmp2 + offsV) * 2748  - *(src_vtmp3 + offsV) * 581;
			tmp = (tmp > 0) ?  (tmp + 16383) >> 15 : 0;
			tmp = (tmp > 255) ? 255 : tmp;
			*(dst_tmp + 1) = tmp;
			//Y1
			*(dst_tmp + 2) = *(src + 1);
			//V0
			tmp =   *src_vtmp0 * 28462 + *src_vtmp1 * 7635
				  - *src_vtmp2 * 2748  - *src_vtmp3 * 581;
			tmp = (tmp > 0) ?  (tmp + 16383) >> 15 : 0;
			tmp = (tmp > 255) ? 255 : tmp;
			*(dst_tmp + 3) = tmp;

			src += 2;
			src_vtmp0++;
			src_vtmp1++;
			src_vtmp2++;
			src_vtmp3++;
			dst_tmp += 4;
		}
	}
}

/*
 * vO YV12 -> YUY2
 * 6Tv
 * W 0.0300, -0.133, 0.890, 0.270, -0.0678, 0.00735
 * 
 * uv_tmp = *(src_vtmp0 + offsV) * 0.89277  + *(src_vtmp1 + offsV) * 0.27101
 *          - *(src_vtmp2 + offsV) * 0.133274 - *(src_vtmp3 + offsV) * 0.067996
 *          + *(src_vtmp4 + offsV) * 0.030112 + *(src_vtmp5 + offsV) * 0.007378;
 */
void yv12_2_yuy2_6(unsigned char *dst, unsigned char *src, unsigned char *temp, 
			long width_in, long width_out, long height)
{
	int i,j;
	int tmp;
	int l1,l2,l3,l4,l5;
	int h_width = width_in >> 1;
	int h_height = height >> 1;
	int offsY = width_in * height;
	int offsV = offsY >> 2;
	unsigned char *dst_tmp = dst;
	unsigned char *src_v = src + offsY;
	unsigned char *src_vtmp0, *src_vtmp1, *src_vtmp2;
	unsigned char *src_vtmp3, *src_vtmp4, *src_vtmp5;

	for(i=0; i<height; ++i) {
		dst_tmp = dst + (i+i) * width_out;
		tmp = i>>1;
		src_vtmp0 = src_v + tmp * h_width;
		l1 = (1&i)*2 - 1;
		l2 = tmp - l1;
		l3 = tmp + l1 + l1;
		l4 = l2 - l1;
		l5 = l3 + l1;
		l1 += tmp;

		if(l5>0 && l5<h_height){
			src_vtmp5 = src_v + l5 * h_width;
			src_vtmp3 = src_v + l3 * h_width;
			src_vtmp1 = src_v + l1 * h_width;
		}else if(l3>0 && l3<h_height){
			src_vtmp5 = src_vtmp3 = src_v + l3 * h_width;
			src_vtmp1 = src_v + l1 * h_width;
		}else if(l1>0 && l1<h_height){
			src_vtmp5 = src_vtmp3 = src_vtmp1 = src_v + l1 * h_width;
		}else{
			src_vtmp5 = src_vtmp3 = src_vtmp1 = src_v;
		}

		if(l4>0 && l4<h_height){
			src_vtmp4 = src_v + l4 * h_width;
			src_vtmp2 = src_v + l2 * h_width;
		}else if(l2>0 && l2<h_height){
			src_vtmp4 = src_vtmp2 = src_v + l2 * h_width;
		}else{
			src_vtmp4 = src_vtmp2 = src_v;
		}

		for(j=0; j<h_width; ++j) {
			//Y0
			*dst_tmp       = *src;
			//U0
			tmp =   *(src_vtmp0 + offsV) * 29254 + *(src_vtmp1 + offsV) * 8880
                  - *(src_vtmp2 + offsV) * 4367  - *(src_vtmp3 + offsV) * 2228
			      + *(src_vtmp4 + offsV) * 987   + *(src_vtmp5 + offsV) * 242;
			tmp = (tmp > 0) ?  (tmp + 16383) >> 15 : 0;
			tmp = (tmp > 255) ? 255 : tmp;
			*(dst_tmp + 1) = tmp;
			//Y1
			*(dst_tmp + 2) = *(src + 1);
			//V0
			tmp =   *src_vtmp0 * 29254 + *src_vtmp1 * 8880
				  - *src_vtmp2 * 4367  - *src_vtmp3 * 2228
				  + *src_vtmp4 * 987   + *src_vtmp5 * 242;
			tmp = (tmp > 0) ?  (tmp + 16383) >> 15 : 0;
			tmp = (tmp > 255) ? 255 : tmp;
			*(dst_tmp + 3) = tmp;

			src += 2;
			src_vtmp0++;
			src_vtmp1++;
			src_vtmp2++;
			src_vtmp3++;
			src_vtmp4++;
			src_vtmp5++;
			dst_tmp += 4;
		}
	}
}

/*
 * interlaced YV12 -> YUY2
 * nearest neighbor
 *
 */
void iyv12_2_yuy2(unsigned char *dst, unsigned char *src, unsigned char *temp, 
			long width_in, long width_out, long height)
{
	int i,j;
	int h_width = width_in >> 1;
	int offsY = width_in * height;
	int offsV = offsY >> 2;
	unsigned char *dst_tmp, *src_vtmp;
	unsigned char *src_v = src + offsY;

	for(i=0; i<height; ++i) {
		dst_tmp = dst + (i+i) * width_out;
		src_vtmp = src_v + (2*(i>>2) + (i&1)) * h_width;
		for(j=0; j<h_width; ++j) {
			//Y0
			*dst_tmp       = *src;
			//U0
			*(dst_tmp + 1) = *(src_vtmp + offsV);
			//Y1
			*(dst_tmp + 2) = *(src + 1);
			//V0
			*(dst_tmp + 3) = *src_vtmp;

			src += 2;
			src_vtmp++;
			dst_tmp += 4;
		}
	}
}

/*
 * interlaced YV12 -> YUY2
 * 2Tv(Tv_YĂ^Cv:MPEG2)
 * W {0.98, 0.02} or {0.7353, 0.2647}
 * 
 */
void iyv12_2_yuy2_2(unsigned char *dst, unsigned char *src, unsigned char *temp, 
			long width_in, long width_out, long height)
{
	int i,j;
	int l0,l1;
	int tmp;
	int h_width = width_in >> 1;
	int h_height = height >> 1;
	int offsY = width_in * height;
	int offsV = offsY >> 2;
	unsigned char *dst_tmp = dst;
	unsigned char *src_v = src + offsY;
	unsigned char *src_vtmp0, *src_vtmp1;

	for(i=0; i<height; ++i) {
		dst_tmp = dst + (i+i) * width_out;

		if(((i+1)>>1)&1) { // i=1,2,5,6,9,10,13,14...
			l0 = (i>>1) + ((1&i)*2 - 1);
			l1 = (i>>1) - ((1&i)*2 - 1);
			if(l1<0 || l1>=h_height) {
				l1 = l0;
			}else if(l0>=h_height){
				l0 = l1;
			}
			src_vtmp0 = src_v + l0 * h_width;
			src_vtmp1 = src_v + l1 * h_width;

			for(j=0; j<h_width; ++j) {
				//Y0
				*dst_tmp       = *src;
				//U0
				tmp = *(src_vtmp0 + offsV) * 24094 + *(src_vtmp1 + offsV) * 8674;
				tmp = (tmp + 16383) >> 15;
				*(dst_tmp + 1) = tmp;
				//Y1
				*(dst_tmp + 2) = *(src + 1);
				//V0
				tmp = *src_vtmp0 * 24094 + *src_vtmp1 * 8674;
				tmp = (tmp + 16383) >> 15;
				*(dst_tmp + 3) = tmp;

				src += 2;
				src_vtmp0++;
				src_vtmp1++;
				dst_tmp += 4;
			}
		}else{ // i=0,3,4,7,8,11,12,15,16,...
			l0 = i>>1;
			l1 = l0 + 2*((1&i)*2 - 1);
			if(l1<0 || l1>=h_height) {
				l1 = l0;
			}
			src_vtmp0 = src_v + l0 * h_width;
			src_vtmp1 = src_v + l1 * h_width;

			for(j=0; j<h_width; ++j) {
				//Y0
				*dst_tmp       = *src;
				//U0
				tmp = *(src_vtmp0 + offsV) * 32113 + *(src_vtmp1 + offsV) * 655;
				tmp = (tmp + 16383) >> 15;
				*(dst_tmp + 1) = tmp;
				//Y1
				*(dst_tmp + 2) = *(src + 1);
				//V0
				tmp = *src_vtmp0 * 32113 + *src_vtmp1 * 655;
				tmp = (tmp + 16383) >> 15;
				*(dst_tmp + 3) = tmp;

				src += 2;
				src_vtmp0++;
				src_vtmp1++;
				dst_tmp += 4;
			}
		}
	}
}

/*
 * interlaced YV12 -> YUY2
 * 2Tv(Tv_^񒆂ɂꍇ)
 * W 0.9, 0.1
 * 
 */
void iyv12_2_yuy2_2x(unsigned char *dst, unsigned char *src, unsigned char *temp, 
			long width_in, long width_out, long height)
{
	int i,j;
	int l0, l1;
	int tmp;
	int h_width = width_in >> 1;
	int h_height = height >> 1;
	int offsY = width_in * height;
	int offsV = offsY >> 2;
	unsigned char *dst_tmp = dst;
	unsigned char *src_v = src + offsY;
	unsigned char *src_vtmp0, *src_vtmp1;

	for(i=0; i<height; ++i) {
		dst_tmp = dst + (i+i) * width_out;
		l0 = 2*(i>>2) + (i&1);
		l1 = l0 + ((i>>1)&1) * 4 - 2;
		if(l1<0 || l1>=h_height) {
			l1 = l0;
		}
		src_vtmp0 = src_v + l0 * h_width;
		src_vtmp1 = src_v + l1 * h_width;

		for(j=0; j<h_width; ++j) {
			//Y0
			*dst_tmp       = *src;
			//U0
			tmp = *(src_vtmp0 + offsV) * 29491 + *(src_vtmp1 + offsV) * 3277;
			tmp = (tmp + 16383) >> 15;
			*(dst_tmp + 1) = tmp;
			//Y1
			*(dst_tmp + 2) = *(src + 1);
			//V0
			tmp = *src_vtmp0 * 29491 + *src_vtmp1 * 3277;
			tmp = (tmp + 16383) >> 15;
			*(dst_tmp + 3) = tmp;

			src += 2;
			src_vtmp0++;
			src_vtmp1++;
			dst_tmp += 4;
		}
	}
}

/*
 * interlaced YV12 -> YUY2
 * 4Tv(Tv_YĂ^Cv)
 * W   {-0.059904, 0.965168, 0.0990252, -0.0042892} 
 *      or{-0.0810047, 0.7276928, 0.3920645, -0.0387526}
 * 
 */
void iyv12_2_yuy2_4(unsigned char *dst, unsigned char *src, unsigned char *temp, 
			long width_in, long width_out, long height)
{
	int i,j;
	int l0,l1,l2,l3;
	int tmp;
	int h_width = width_in >> 1;
	int h_height = height >> 1;
	int offsY = width_in * height;
	int offsV = offsY >> 2;
	unsigned char *dst_tmp = dst;
	unsigned char *src_v = src + offsY;
	unsigned char *src_vtmp0, *src_vtmp1,*src_vtmp2, *src_vtmp3;

	for(i=0; i<height; ++i) {
		dst_tmp = dst + (i+i) * width_out;

		if(((i+1)>>1)&1) { // i=1,2,5,6,9,10,13,14...
			l0 = (i>>1) + ((1&i)*2 - 1);
			l1 = (i>>1) - ((1&i)*2 - 1);
			l2 = l0 + (1&i)*4 - 2;
			l3 = l1 - (1&i)*4 + 2;
			if(l1<0 || l1>=h_height) {
				l1 = l0;
			}else if(l0>=h_height){
				l0 = l1;
			}
			if(l2<0 || l2>=h_height) {
				l2 = l0;
			}
			if(l3<0 || l3>=h_height) {
				l3 = l1;
			}

			src_vtmp0 = src_v + l0 * h_width;
			src_vtmp1 = src_v + l1 * h_width;
			src_vtmp2 = src_v + l2 * h_width;
			src_vtmp3 = src_v + l3 * h_width;

			for(j=0; j<h_width; ++j) {
				//Y0
				*dst_tmp       = *src;
				//U0
				tmp =   *(src_vtmp0 + offsV) * 23845 + *(src_vtmp1 + offsV) * 12847
					  - *(src_vtmp2 + offsV) * 2654  - *(src_vtmp3 + offsV) * 1270;
				tmp = (tmp > 0) ?  (tmp + 16383) >> 15 : 0;
				tmp = (tmp > 255) ? 255 : tmp;
				*(dst_tmp + 1) = tmp;
				//Y1
				*(dst_tmp + 2) = *(src + 1);
				//V0
				tmp =   *src_vtmp0 * 23845 + *src_vtmp1 * 12847
					  - *src_vtmp2 * 2654  - *src_vtmp3 * 1270;
				tmp = (tmp > 0) ?  (tmp + 16383) >> 15 : 0;
				tmp = (tmp > 255) ? 255 : tmp;
				*(dst_tmp + 3) = tmp;

				src += 2;
				src_vtmp0++;
				src_vtmp1++;
				src_vtmp2++;
				src_vtmp3++;
				dst_tmp += 4;
			}
		}else{ // i=0,3,4,7,8,11,12,15,16,...
			l0 = i>>1;
			l1 = l0 + 2*((1&i)*2 - 1);
			l2 = l0 - 2*((1&i)*2 - 1);
			l3 = l1 + 2*((1&i)*2 - 1);
			if(l1<0 || l1>=h_height) {
				l1 = l0;
			}
			if(l2<0 || l2>=h_height) {
				l2 = l0;
			}
			if(l3<0 || l3>=h_height) {
				l3 = l1;
			}
			src_vtmp0 = src_v + l0 * h_width;
			src_vtmp1 = src_v + l1 * h_width;
			src_vtmp2 = src_v + l2 * h_width;
			src_vtmp3 = src_v + l3 * h_width;

			for(j=0; j<h_width; ++j) {
				//Y0
				*dst_tmp       = *src;
				//U0
				tmp =   *(src_vtmp0 + offsV) * 31626 + *(src_vtmp1 + offsV) * 3245
					  - *(src_vtmp2 + offsV) * 1963  - *(src_vtmp3 + offsV) * 140;
				tmp = (tmp > 0) ?  (tmp + 16383) >> 15 : 0;
				tmp = (tmp > 255) ? 255 : tmp;
				*(dst_tmp + 1) = tmp;
				//Y1
				*(dst_tmp + 2) = *(src + 1);
				//V0
				tmp =   *src_vtmp0 * 31626 + *src_vtmp1 * 3245
					  - *src_vtmp2 * 1963  - *src_vtmp3 * 140;
				tmp = (tmp > 0) ?  (tmp + 16383) >> 15 : 0;
				tmp = (tmp > 255) ? 255 : tmp;
				*(dst_tmp + 3) = tmp;

				src += 2;
				src_vtmp0++;
				src_vtmp1++;
				src_vtmp2++;
				src_vtmp3++;
				dst_tmp += 4;
			}
		}
	}
}

/*
 * interlaced YV12 -> YUY2
 * 4Tv(Tv_^񒆂ɂꍇ)
 * W -0.08388, 0.8686, 0.2330, -0.01772
 * 
 */
void iyv12_2_yuy2_4x(unsigned char *dst, unsigned char *src, unsigned char *temp, 
			long width_in, long width_out, long height)
{
	int i,j;
	int l0, l1, l2, l3;
	int tmp;
	//double tmp;
	int h_width = width_in >> 1;
	int h_height = height >> 1;
	int offsY = width_in * height;
	int offsV = offsY >> 2;
	unsigned char *dst_tmp = dst;
	unsigned char *src_v = src + offsY;
	unsigned char *src_vtmp0, *src_vtmp1, *src_vtmp2, *src_vtmp3;

	for(i=0; i<height; ++i) {
		dst_tmp = dst + (i+i) * width_out;
		l0 = 2*(i>>2) + (i&1);
		l1 = l0 + ((i>>1)&1) * 4 - 2;
		l2 = l0 - ((i>>1)&1) * 4 + 2;
		l3 = l1 + ((i>>1)&1) * 4 - 2;
		if(l1<0 || l1>=h_height) {
			l1 = l0;
		}
		if(l2<0 || l2>=h_height) {
			l2 = l0;
		}
		if(l3<0 || l3>=h_height) {
			l3 = l1;
		}

		src_vtmp0 = src_v + l0 * h_width;
		src_vtmp1 = src_v + l1 * h_width;
		src_vtmp2 = src_v + l2 * h_width;
		src_vtmp3 = src_v + l3 * h_width;

		for(j=0; j<h_width; ++j) {
			//Y0
			*dst_tmp       = *src;
			//U0
			tmp =   *(src_vtmp0 + offsV) * 28462 + *(src_vtmp1 + offsV) * 7635
				  - *(src_vtmp2 + offsV) * 2748  - *(src_vtmp3 + offsV) * 581;
			tmp = (tmp > 0) ?  (tmp + 16383) >> 15 : 0;
			tmp = (tmp > 255) ? 255 : tmp;
			*(dst_tmp + 1) = tmp;
			//Y1
			*(dst_tmp + 2) = *(src + 1);
			//V0
			tmp =   *src_vtmp0 * 28462 + *src_vtmp1 * 7635
				  - *src_vtmp2 * 2748  - *src_vtmp3 * 581;
			tmp = (tmp > 0) ?  (tmp + 16383) >> 15 : 0;
			tmp = (tmp > 255) ? 255 : tmp;
			*(dst_tmp + 3) = tmp;

			src += 2;
			src_vtmp0++;
			src_vtmp1++;
			src_vtmp2++;
			src_vtmp3++;
			dst_tmp += 4;
		}
	}
}


// [eBeB[֐
/*
 *  ]uRs[
 *  unsigned char *dst 
 *  unsigned char *src idst != src łȂƂ߁j
 *  long w      ͉摜̂͂
 *  long h      ͉摜̍
 *  long guard  ݍ݂̂߂̃J[hoĥ͂΁ij
 */
void transpose(unsigned char *dst, unsigned char *src, long w, long h, long guard)
{
	int i,j,k;
	int hg = h + guard * 2;

	for(i=0; i<hg; ++i) {
		if(i<guard){
			k = 0;
		}else if(i<hg-guard){
			k = i - guard;
		}else{
			k = h - 1;
		}
		for(j=0; j<w; ++j) {
			dst[j*hg + i] = src[k*w + j];
		}
	}
}

